#ifndef _MODBUS_MSXE3317_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE3317_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Mon Oct 27 09:48:53 2014*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE3317__PRESSUREGETNUMBEROFCHANNELS=21000,
MSXE3317__PRESSURECALIBRATIONGETCURRENTSTATUS=21150,
MSXE3317__ACQUISITIONGETNUMBEROFCHANNELS=15000,
MSXE3317__ACQUISITIONGETCHANNELSINFO=15050,
MSXE3317__ACQUISITIONAUTOREFRESHGETVALUES=15300,
MSXE3317__ACQUISITIONAUTOREFRESHGETBLOCKINGVALUES=15450,
MSXE3317__ACQUISITIONAUTOREFRESHGETCONFIGURATION=15600,
MSXE3317__ACQUISITIONSEQUENCEGETCONFIGURATION=15650,
MSXE3317__DIGITALIOGETNUMBEROFCHANNELS=26000,
MSXE3317__DIGITALIOGETNUMBEROFPORTS=26050,
MSXE3317__DIGITALIOGETPORTAVAILABLEDIRECTIONS=26100,
MSXE3317__DIGITALIOGETPORTDIRECTIONS=26150,
MSXE3317__DIGITALIOGETINPUTSFILTERCONFIGURATION=26200,
MSXE3317__DIGITALIOTESTOUTPUTSSHORTCIRCUIT=26250,
MSXE3317__DIGITALIOREADCHANNEL=26300,
MSXE3317__DIGITALIOREADPORT=26350,
MSXE3317__SINCOSGETNUMBEROFCHANNELS=37000,
MSXE3317__SINCOSREAD=37100,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE3317__PressureGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE3317__PressureCalibrationGetCurrentStatus_parameters_t
{
	uint32_t ulStatus;
	uint32_t ulChannel;
	float fRefValue;
	uint32_t ulDigitalValue;
 } __PACKED;

struct MSXE3317__AcquisitionGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE3317__AcquisitionGetChannelsInfo_parameters_t
{
	uint32_t ulType[16];
	uint32_t ulHwPosition[16];
	uint32_t ulChannelIndex[16];
 } __PACKED;

struct MSXE3317__AcquisitionAutoRefreshGetValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE3317__AcquisitionAutoRefreshGetBlockingValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	float fValues[16];
 } __PACKED;

struct MSXE3317__AcquisitionAutoRefreshGetConfiguration_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

struct MSXE3317__AcquisitionSequenceGetConfiguration_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulRunning;
 } __PACKED;

struct MSXE3317__DigitalIOGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE3317__DigitalIOGetNumberOfPorts_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE3317__DigitalIOGetPortAvailableDirections_parameters_t
{
	uint32_t ulInputs;
	uint32_t ulOutputs;
 } __PACKED;

struct MSXE3317__DigitalIOGetPortDirections_parameters_t
{
	uint32_t ulDirection;
 } __PACKED;

struct MSXE3317__DigitalIOGetInputsFilterConfiguration_parameters_t
{
	uint32_t ulFilterTime;
	uint32_t ulFilter;
 } __PACKED;

struct MSXE3317__DigitalIOTestOutputsShortCircuit_parameters_t
{
	uint32_t ulState;
 } __PACKED;

struct MSXE3317__DigitalIOReadChannel_parameters_t
{
	uint32_t ulState;
 } __PACKED;

struct MSXE3317__DigitalIOReadPort_parameters_t
{
	uint32_t ulState;
 } __PACKED;

struct MSXE3317__SinCosGetNumberOfChannels_parameters_t
{
	uint32_t ulNumber;
 } __PACKED;

struct MSXE3317__SinCosRead_parameters_t
{
	float fValue;
	uint32_t ulValue;
	uint32_t ulMeasureError;
	uint32_t ulInfo01;
	uint32_t ulInfo02;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Return the number of pressure channels.</p>
* <p>
* <b>Parameters:</b>
* </p>
* <ul>
* <p>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available pressure channels</p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__PressureGetNumberOfChannels(struct modbus * modbus,struct MSXE3317__PressureGetNumberOfChannels_parameters_t * Response);



/** <p>Return the type of the analog input channels</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p> @param[out] <b> <VAR>ulStatus </VAR> </b> Calibration current status
* <ul>
*                  <li> 0: No calibration in progress
*                  <li> 1: Wait to setting the reference value
*                  <li> 2: Selected reference value calibration in progress
*                  <li> 3: Calibration finiched
*                  <li> 4: User break occur
*                  <li> 5: Can not calibrate the selected reference value
* </ul>
* </p>
* <p> @param[out] <b> <VAR>ulChannel : </VAR> </b> Current calibration channel </p>
* <p> @param[out] <b> <VAR>fRefValue : </VAR> </b> Current selected calibration reference value </p>
* <p> @param[out] <b> <VAR>ulDigitalValue : </VAR> </b> Last measured digital value </p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__PressureCalibrationGetCurrentStatus(struct modbus * modbus,struct MSXE3317__PressureCalibrationGetCurrentStatus_parameters_t * Response);



/** <p>Return the number of acquisition channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Return the number of available acquisition channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionGetNumberOfChannels(struct modbus * modbus,struct MSXE3317__AcquisitionGetNumberOfChannels_parameters_t * Response);



/** <p>Return the acquisition channels type and hardware position.</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulType </VAR> </b> Array that contains the channels type.
* 		<ul>
*			<li> 0 : Not available </li>
*			<li> 1 : Temperature channel </li>
*			<li> 2 : Pressure channel </li>
*			<li> 3 : Transducer channel </li>
*			<li> 4 : Analog input channel </li>
*			<li> 5 : Analog input ICP channel </li>
*			<li> 6 : Digital I/O port </li>
*		</ul>
*		<ul>
*			<li> ulType [0] : Channel 0 type</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 type</li>
*		</ul>
*	</li>
*	<li>@param[out] <b> <VAR>ulHwPosition </VAR> </b> Array that contain the hardware position index (0 to 7)
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 hardware position index</li>
*		</ul>
* 	</li>
*	<li>@param[out] <b> <VAR>ulChannelIndex </VAR> </b> Array that contain the functionality channel index.
* 		<ul>
*			<li> ulType [0] : Channel 0 hardware position index</li>
*			<li> ...</li>
*			<li> ulType [15] : Channel 15 functionality channel index</li>
*		</ul>
*	</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Channel selection wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionGetChannelsInfo(struct modbus * modbus,struct MSXE3317__AcquisitionGetChannelsInfo_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionAutoRefreshGetValues(struct modbus * modbus,struct MSXE3317__AcquisitionAutoRefreshGetValues_parameters_t * Response);



/** <p> Returns the values acquired in auto refresh mode after a new cycle occur (wait a new auto refresh value cycle)</p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulTimeStampLow</VAR> </b> Number of microseconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulTimeStampHigh </VAR> </b> Number of seconds since epoch</li>
* 	<li>@param[out] <b> <VAR>ulAutoRefreshCounter </VAR> </b> Number of sequence acquisition since the start</li>
* 	<li>@param[out] <b> <VAR>fValues </VAR> </b> Array that contains the channels values
*		<ul>
*			<li> pdValues [0] : Channel 0 value</li>
*			<li>  ...</li>
*			<li> pdValues [15] : Channel 15 value</li>
* 		</ul>
*	</li>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No Acquisition in progress</li>
*	<li><b>-3</b> 2s timeout occur (If you have enabled the blocking mode).</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus,struct MSXE3317__AcquisitionAutoRefreshGetBlockingValues_parameters_t * Response);



/** <p> Get the current auto refresh acquisition configuration. </p>
* <p><b>Parameters:</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulChannelMask </VAR></b> Mask of the channel acquired by the auto refresh (1 bit = 1 Channel). If the value returned is 0, then the auto refresh acquisition is not initialised. </li>
* 	<li>@param[out] <b><VAR> ulAverageValue </VAR></b> Average value
*		<ul>
*			<li> 1 : not used </li>
*			<li> max value : 255 </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input)</li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Auto refresh acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Auto refresh acquisition running </li>
*		</ul>
*	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionAutoRefreshGetConfiguration(struct modbus * modbus,struct MSXE3317__AcquisitionAutoRefreshGetConfiguration_parameters_t * Response);



/** <p> Get the current sequence acquisition configuration.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR> ulNbrOfChannel </VAR></b> Nbr of channel in the sequence. If 0 no sequence initialised</li>
* 	<li>@param[out] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[out] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input) </li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
*	<li>@param[out] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information</li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[out] <b><VAR> ulRunning </VAR></b> Sequence acquisition running state
*		<ul>
*			<li> 0 : Not running</li>
*			<li> 1 : Sequence acquisition running </li>
*		</ul>
* 	</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__AcquisitionSequenceGetConfiguration(struct modbus * modbus,struct MSXE3317__AcquisitionSequenceGetConfiguration_parameters_t * Response);



/** <p>Returns the number of digital I/O channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Number of available digital I/O channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOGetNumberOfChannels(struct modbus * modbus,struct MSXE3317__DigitalIOGetNumberOfChannels_parameters_t * Response);



/** <p>Returns the number of digital I/O ports. A port is a set of consecutive digital I/O channels, whose status can be written or read at the same time.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulNumber </VAR> </b> Number of available digital I/O ports</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOGetNumberOfPorts(struct modbus * modbus,struct MSXE3317__DigitalIOGetNumberOfPorts_parameters_t * Response);



/** <p>Returns the available directions for the selected port (input or output). The port is selected via MSXE3317__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulInputs </VAR> </b> Digital inputs availability. Each bit indicates if the channel can be used as an input.</li>
* 	<li>@param[out] <b> <VAR>ulOutputs </VAR> </b> Digital outputs availability. Each bit indicates if the channel can be used as an output.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOGetPortAvailableDirections(struct modbus * modbus,struct MSXE3317__DigitalIOGetPortAvailableDirections_parameters_t * Response);



/** <p>Reads the current digital I/O direction for the selected port. The port is selected via MSXE3317__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulDirection </VAR> </b> Current digital I/O direction. Each bit indicates if the channel is used as an input or an output (0: input, 1: output)</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOGetPortDirections(struct modbus * modbus,struct MSXE3317__DigitalIOGetPortDirections_parameters_t * Response);



/** <p>Reads the digital inputs filter configuration for the selected port. The port is selected via MSXE3317__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulFilterTime </VAR> </b> Filter time value (from 1 to 16777215) 1 corresponds to 250 ns, 2 corresponds to 500 ns, ...</li>
* 	<li>@param[out] <b> <VAR>ulFilter </VAR> </b> Digital inputs filter selection. Each bit indicate the filter state for one digital input channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOGetInputsFilterConfiguration(struct modbus * modbus,struct MSXE3317__DigitalIOGetInputsFilterConfiguration_parameters_t * Response);



/** <p>Get the short-circuit status of the outputs of the selected port. The port is selected via MSXE3317__SetDataCursor.</p>
* <p>The function returns a mask of bits (32 bits). Each bit represents the short-circuit state of an output.</p>
* <p>If you detect a short circuit, first solve it, and then, call the MSXE3317__DigitalIORearmOutputsShortCircuit function.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital outputs short circuit state. Each bit represents the short-circuit state of one digital output channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOTestOutputsShortCircuit(struct modbus * modbus,struct MSXE3317__DigitalIOTestOutputsShortCircuit_parameters_t * Response);



/** <p>Read the selected digital I/O channel. The channel is selected via MSXE3317__SetDataCursor.</p>
* <p>If the selected channel is an output, then this function returns the current output state.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital I/O channel state (0: off, 1: on)</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected channel (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOReadChannel(struct modbus * modbus,struct MSXE3317__DigitalIOReadChannel_parameters_t * Response);



/** <p>Read the selected digital I/O port. The port is selected via MSXE3317__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b> <VAR>ulState </VAR> </b> Digital I/O state. Each bit indicates the state of one digital I/O channel.</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The selected port (selected via MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__DigitalIOReadPort(struct modbus * modbus,struct MSXE3317__DigitalIOReadPort_parameters_t * Response);



/** <p>Return the number of Sine/Cosine channels.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR>ulNumber</VAR></b> Number of available Sine / Cosine channels</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__SinCosGetNumberOfChannels(struct modbus * modbus,struct MSXE3317__SinCosGetNumberOfChannels_parameters_t * Response);



/** <p>Read the measured value of the selected Sine/Cosine channel. The channel is selected via MSXE3317__SetDataCursor.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[out] <b><VAR>fValue</VAR></b> Measured value (Unit)</li>
*	<li>@param[out] <b><VAR>ulValue</VAR></b> Measured value (Raw value)</li>
*	<li>@param[out] <b><VAR>ulMeasureError</VAR></b> Status of the Sine/Cosine measurement. If the value is 1, then an error occurred. When an error occurred, the reference point is corrupted. To correct it, you must first reset the error flag using the function SinCosClearError, and then reset your reference point.</li>
*	<li>@param[out] <b><VAR>ulInfo01</VAR></b> Reserved</li>
*	<li>@param[out] <b><VAR>ulInfo02</VAR></b> Reserved</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The selected channel (using MSXE3317__SetDataCursor) is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE3317__SinCosRead(struct modbus * modbus,struct MSXE3317__SinCosRead_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE3317__SETDATACURSOR=65530,
MSXE3317__PRESSURESETCHANNELCONFIGURATION=21200,
MSXE3317__PRESSURESETSAMPLINGRATE=21250,
MSXE3317__PRESSURECALIBRATIONSTART=21300,
MSXE3317__PRESSURECALIBRATIONNEXTSTEP=21350,
MSXE3317__PRESSURECALIBRATIONBREAK=21400,
MSXE3317__ACQUISITIONAUTOREFRESHINITANDSTART=15750,
MSXE3317__ACQUISITIONAUTOREFRESHSTOPANDRELEASE=15850,
MSXE3317__ACQUISITIONSEQUENCEINITANDSTART=15900,
MSXE3317__ACQUISITIONSEQUENCESTOPANDRELEASE=15950,
MSXE3317__DIGITALIOSETPORTDIRECTIONS=26500,
MSXE3317__DIGITALIOSETINPUTSFILTERTIME=26550,
MSXE3317__DIGITALIOENABLEDISABLEINPUTSFILTER=26600,
MSXE3317__DIGITALIOREARMOUTPUTSSHORTCIRCUIT=26650,
MSXE3317__DIGITALIOWRITECHANNEL=26700,
MSXE3317__DIGITALIOWRITEPORT=26750,
MSXE3317__SINCOSINIT=37200,
MSXE3317__SINCOSRELEASE=37300,
MSXE3317__SINCOSCLEAR=37400,
MSXE3317__SINCOSCLEARERROR=37500,
MSXE3317__SINCOSINITINDEX=37600,
MSXE3317__SINCOSRELEASEINDEX=37700,
MSXE3317__SINCOSINITANDENABLECOMPARELOGIC=37800,
MSXE3317__SINCOSDISABLEANDRELEASECOMPARELOGIC=37900,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE3317__SetDataCursor_parameters_t
{
	uint32_t ulCursor;
 } __PACKED;

struct MSXE3317__PressureSetChannelConfiguration_parameters_t
{
	uint32_t ulChannel;
	float fSensorSensibility;
	float fSensorOffset;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__PressureSetSamplingRate_parameters_t
{
	uint32_t ulChannelGroup;
	uint32_t ulBaseSamplingRate;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__PressureCalibrationStart_parameters_t
{
	uint32_t ulChannelGroup;
	uint32_t ulGainSelection;
	uint32_t ulNbrOfRefValues;
	float fRefValues[16];
 } __PACKED;

struct MSXE3317__PressureCalibrationNextStep_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE3317__PressureCalibrationBreak_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE3317__AcquisitionAutoRefreshInitAndStart_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE3317__AcquisitionAutoRefreshStopAndRelease_parameters_t
{
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__AcquisitionSequenceInitAndStart_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE3317__AcquisitionSequenceStopAndRelease_parameters_t
{
	uint32_t ulOption01;
 } __PACKED;

struct MSXE3317__DigitalIOSetPortDirections_parameters_t
{
	uint32_t ulPort;
	uint32_t ulDirection;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__DigitalIOSetInputsFilterTime_parameters_t
{
	uint32_t ulFilterTime;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__DigitalIOEnableDisableInputsFilter_parameters_t
{
	uint32_t ulPort;
	uint32_t ulFilter;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__DigitalIORearmOutputsShortCircuit_parameters_t
{
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__DigitalIOWriteChannel_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulState;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__DigitalIOWritePort_parameters_t
{
	uint32_t ulPort;
	uint32_t ulState;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE3317__SinCosInit_parameters_t
{
	uint32_t ulChannel;
	float fSignalPeriod;
	uint32_t ulResolution;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;
 } __PACKED;

struct MSXE3317__SinCosRelease_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosClear_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosClearError_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosInitIndex_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulEdge;
	uint32_t ulAction;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosReleaseIndex_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosInitAndEnableCompareLogic_parameters_t
{
	uint32_t ulChannel;
	float fValue;
	uint32_t ulValueFormat;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE3317__SinCosDisableAndReleaseCompareLogic_parameters_t
{
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Change the active data cursor cursor</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>ulCursor:</VAR></b> New cursor value </p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SetDataCursor(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulCursor;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SetDataCursor(modbus,ulCursor,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SetDataCursor");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SetDataCursor\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SetDataCursor()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SetDataCursor OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SetDataCursor(struct modbus * modbus,
	uint32_t ulCursor
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Pressure sensor configuration for the selected channel</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannel </VAR></b> Channel selection. 0 to 15</p>
* <p>@param[in] <b><VAR> fSensorSensibility </VAR></b> Sensor sensibility (mV/V/bar or mV/V/mbar or mV/V/Pa, ...). Refer to sensor documentation<ul>
* <p>@param[in] <b><VAR> fSensorOffset </VAR></b> Sensor V offset for 0 mV/V/bar, 0 mV/V/mbar, ... Refer to sensor documentation<ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__PressureSetChannelConfiguration(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	float fSensorSensibility;
	float fSensorOffset;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__PressureSetChannelConfiguration(modbus,ulChannel,fSensorSensibility,fSensorOffset,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__PressureSetChannelConfiguration");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__PressureSetChannelConfiguration\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__PressureSetChannelConfiguration()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__PressureSetChannelConfiguration OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__PressureSetChannelConfiguration(struct modbus * modbus,
	uint32_t ulChannel,
	float fSensorSensibility,
	float fSensorOffset,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Pressure acquisition sampling rate selection</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannelGroup </VAR></b> Channel group selection.<ul>
*                       <li> 0 for channels 0 and 1
*			<li> 1 for channels 2 and 3
*			<li> 2 for channels 4 and 5
*			<li> 3 for channels 6 and 7
*			<li> 4 for channels 8 and 9
*			<li> 5 for channels 10 and 11
*			<li> 6 for channels 12 and 13
*			<li> 7 for channels 14 and 15
*			<li> ...
*			<li> 255 for all channels</ul></p>
* <p>@param[in] <b><VAR> ulBaseSamplingRate </VAR></b> Sampling rate selection<ul>
*			<li> 5 for 5Hz
*			<li> 10 for 10Hz
*			<li> 20 for 20Hz
*			<li> 40 for 40Hz
*			<li> 80 for 80Hz
*			<li> 160 for 160Hz
*			<li> 320 for 320Hz
*			<li> 640 for 640Hz
*			<li> 1000 for 1000Hz
*			<li> 2000 for 2000Hz</ul></p>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__PressureSetSamplingRate(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelGroup;
	uint32_t ulBaseSamplingRate;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__PressureSetSamplingRate(modbus,ulChannelGroup,ulBaseSamplingRate,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__PressureSetSamplingRate");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__PressureSetSamplingRate\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__PressureSetSamplingRate()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__PressureSetSamplingRate OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__PressureSetSamplingRate(struct modbus * modbus,
	uint32_t ulChannelGroup,
	uint32_t ulBaseSamplingRate,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function start the calibration thread</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulChannelGroup </VAR></b> Channel group selection.<ul>
*                       <li> 0 for channels 0 and 1
*			<li> 1 for channels 2 and 3
*			<li> 2 for channels 4 and 5
*			<li> 3 for channels 6 and 7
*			<li> 4 for channels 8 and 9
*			<li> 5 for channels 10 and 11
*			<li> 6 for channels 12 and 13
*			<li> 7 for channels 14 and 15
*			<li> ...</ul></p>
* <p>@param[in] <b><VAR> ulGainSelection </VAR></b>Selected gain (1, 2, 4, 8, 16, 32, 64 or 128)</p>
* <p>@param[in] <b><VAR> ulNbrOfRefValues </VAR></b> Nbr of channel reference values used for the calibration (Max 16)</p>
* <p>@param[in] <b><VAR> fRefValues </VAR></b> Reference voltage values for the calibration (Max 16)</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__PressureCalibrationStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelGroup;
	uint32_t ulGainSelection;
	uint32_t ulNbrOfRefValues;
	float fRefValues[16];

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__PressureCalibrationStart(modbus,ulChannelGroup,ulGainSelection,ulNbrOfRefValues,fRefValues,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__PressureCalibrationStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__PressureCalibrationStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__PressureCalibrationStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__PressureCalibrationStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__PressureCalibrationStart(struct modbus * modbus,
	uint32_t ulChannelGroup,
	uint32_t ulGainSelection,
	uint32_t ulNbrOfRefValues,
	float fRefValues[16]
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function start the next calibration step</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__PressureCalibrationNextStep(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__PressureCalibrationNextStep(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__PressureCalibrationNextStep");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__PressureCalibrationNextStep\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__PressureCalibrationNextStep()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__PressureCalibrationNextStep OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__PressureCalibrationNextStep(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>This function break the current calibration</p>
*<p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</p>
*
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__PressureCalibrationBreak(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__PressureCalibrationBreak(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__PressureCalibrationBreak");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__PressureCalibrationBreak\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__PressureCalibrationBreak()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__PressureCalibrationBreak OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__PressureCalibrationBreak(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start an auto refresh acquisition using provided configuration</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannelMask </VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel). 0 for all available acquisition channels </li>
* 	<li>@param[in] <b><VAR> ulAverageValue </VAR></b> Set the average value
*		<ul>
*			<li> 1 : not used</li>
*			<li> max value : 255</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTimeUnit </VAR></b> Refresh Time Unit
*		<ul>
*			<li> 0 : microsecond</li>
*			<li> 1 : millisecond</li>
*			<li> 2 : second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulRefreshTime </VAR></b> Refresh Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger </li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input) </li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generates a trigger action
*		<ul>
*			<li> 1 : rising edge (Only if hardware trigger selected)</li>
*			<li> 2 : falling edge (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> Define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b>
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Auto refresh counter information
*				<ul>
*					<li>  0 : No auto refresh counter information</li>
*					<li>  1 : Auto refresh counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-4</b> Channel Mask error</li>
*	<li><b>-5</b> Not available average value</li>
*	<li><b>-6</b> Not available refresh time unit</li>
*	<li><b>-7</b> The minimal refresh time is 1000 us</li>
*	<li><b>-8</b> The maximal refresh time is 65535</li>
*	<li><b>-9</b> Trigger mask not available</li>
*	<li><b>-10</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-11</b> Trigger mode not available</li>
*	<li><b>-12</b> Trigger mask : 2 trigger mode cannot be simultaneously activated</li>
*	<li><b>-13</b> Hardware trigger : front definition error</li>
*	<li><b>-14</b> Hardware trigger count value not available</li>
*	<li><b>-15</b> Nbr of sequence to acquire by trigger mode not available</li>
*	<li><b>-16</b> Data format not available</li>
*	<li><b>-17</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelMask;
	uint32_t ulAverageValue;
	uint32_t ulRefreshTime;
	uint32_t ulRefreshTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__AcquisitionAutoRefreshInitAndStart(modbus,ulChannelMask,ulAverageValue,ulRefreshTime,ulRefreshTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__AcquisitionAutoRefreshInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__AcquisitionAutoRefreshInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__AcquisitionAutoRefreshInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__AcquisitionAutoRefreshInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__AcquisitionAutoRefreshInitAndStart(struct modbus * modbus,
	uint32_t ulChannelMask,
	uint32_t ulAverageValue,
	uint32_t ulRefreshTime,
	uint32_t ulRefreshTimeUnit,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p> Stops the current auto refresh acquisition</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__AcquisitionAutoRefreshStopAndRelease(modbus,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__AcquisitionAutoRefreshStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__AcquisitionAutoRefreshStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__AcquisitionAutoRefreshStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__AcquisitionAutoRefreshStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__AcquisitionAutoRefreshStopAndRelease(struct modbus * modbus,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the sequence acquisition mode</p>
*<p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulNbrOfChannel </VAR></b> Number of channel in the sequence</li>
* 	<li>@param[in] <b><VAR> psChannelList </VAR></b> List of the channel who compose the sequence.</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTime </VAR></b> Acquisition Time
*		<ul>
*			<li> range from min 1000 to 65535 when the unit is the microsecond</li>
*			<li> range from min 1 to 65535 when the unit is the millisecond</li>
*			<li> range from min 1 to 65535 when the unit is the second </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulAcquisitionTimeUnit </VAR></b> Acquisition Time Unit
*		<ul>
*			<li> 0 : us</li>
*			<li> 1 : ms</li>
*			<li> 2 : s </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrOfSequence </VAR></b> Number of sequence to acquire
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulNbrMaxSequenceToTransfer </VAR></b> Max number of sequence to acquire before a data transfer. (from 1 to 65535)</li>
* 	<li>@param[in] <b><VAR> ulTriggerMask </VAR></b> Define the source of the trigger
*		<ul>
*			<li> 0 : trigger disabled</li>
*			<li> 1 : Enable Hardware Digital Input Trigger</li>
*			<li> 2 : Enable Synchro Trigger</li>
*			<li> 4 : Enable Compare Trigger (only useful if your system has incremental counter or Sine/Cosine input)</li>
*			<li> 8 : Enable Index Trigger (only useful if your system has Sine/Cosine input)</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulTriggerMode </VAR></b> Define the trigger mode
*		<ul>
*			<li> 1 : One shot trigger</li>
*			<li> 2 : Sequence trigger </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerEdge </VAR></b> Define the edge of the hardware trigger who generate a trigger action
*		<ul>
*			<li> 1 : rising front (Only if hardware trigger selected)</li>
*			<li> 2 : falling front (Only if hardware trigger selected)</li>
*			<li> 3 : Both front (Only if hardware trigger selected) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulHardwareTriggerCount </VAR></b> Define the number of trigger events before the action occur
*		<ul>
*			<li> 1 : all trigger event start the action</li>
*			<li> max value : 65535 </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulByTriggerNbrOfSeqToAcquire </VAR></b> define the number of sequence to acquire by each trigger event
*		<ul>
*			<li> 0 : continuous mode</li>
*			<li> Superior to 0 : number of sequence : (1..0xFFFFFFFF) </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulDataFormat </VAR></b> Data format option
*		<ul>
*			<li> D0 : Absolute time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information</li>
*				</ul>
*			</li>
*			<li> D1 : Relative time stamp information
*				<ul>
*					<li> 0: no time stamp information</li>
*					<li> 1: time stamp information </li>
*				</ul>
*			</li>
*			<li> D2 : Sequence counter information
*				<ul>
*					<li> 0 : No sequence counter information</li>
*					<li> 1 : Sequence counter information </li>
*				</ul>
*			</li>
*			<li> D3 : System status information
*				<ul>
*					<li>  0 : No system status information required</li>
*					<li>  1 : System status information required</li>
*				</ul>
*			</li>
*			<li> D4 : Data format
*				<ul>
*					<li> 0: Digital value</li>
*					<li> 1: Analog value </li>
*				</ul>
*			</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulForceStart </VAR></b>
*		<ul>
*			<li> 0 : Function return a error if any acquisition already in progress</li>
*			<li> 1 : If any acquisition in progress then stop this </li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> Any acquisition already in progress</li>
*	<li><b>-3</b> The number of channel in the sequence is null or to high</li>
*	<li><b>-4</b> Channel index selection error</li>
*	<li><b>-5</b> Channel already selected</li>
*	<li><b>-6</b> Any selected channel not OK, call the diagnostic function for more information</li>
*	<li><b>-7</b> Not available acquisition time unit</li>
*	<li><b>-8</b> The minimal acquisition time is 1000 us !</li>
*	<li><b>-9</b> The maximal acquisition time is 65535 !</li>
*	<li><b>-10</b> Transfer sequence size error (1 to 4096) !</li>
*	<li><b>-11</b> The total number of sequences is not a multiple from number of sequences to transfer</li>
*	<li><b>-12</b> Trigger mask not available</li>
*	<li><b>-13</b> Trigger mask : 2 different trigger source cannot be simultaneously be activated</li>
*	<li><b>-14</b> Trigger mode not available</li>
*	<li><b>-15</b> Trigger mask : 2 trigger mode cannot be simultaneously be activated</li>
*	<li><b>-16</b> Hardware trigger : front definition error</li>
*	<li><b>-17</b> Hardware trigger count value not available</li>
*	<li><b>-18</b> Number of sequence to acquire by trigger mode not available</li>
*	<li><b>-19</b> Data format not available</li>
*	<li><b>-20</b> Selected channels combination not available</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__AcquisitionSequenceInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulNbrOfChannel;
	uint32_t ulChannelList[16];
	uint32_t ulAcquisitionTime;
	uint32_t ulAcquisitionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulForceStart;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__AcquisitionSequenceInitAndStart(modbus,ulNbrOfChannel,ulChannelList,ulAcquisitionTime,ulAcquisitionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulForceStart,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__AcquisitionSequenceInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__AcquisitionSequenceInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__AcquisitionSequenceInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__AcquisitionSequenceInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__AcquisitionSequenceInitAndStart(struct modbus * modbus,
	uint32_t ulNbrOfChannel,
	uint32_t ulChannelList[16],
	uint32_t ulAcquisitionTime,
	uint32_t ulAcquisitionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulForceStart,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the sequence acquisition mode</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set to 0</li>
* </ul>
* <p><b> Returns:</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> No sequence acquisition in progress</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__AcquisitionSequenceStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__AcquisitionSequenceStopAndRelease(modbus,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__AcquisitionSequenceStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__AcquisitionSequenceStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__AcquisitionSequenceStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__AcquisitionSequenceStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__AcquisitionSequenceStopAndRelease(struct modbus * modbus,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p> Write the current digital I/O direction for the selected port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE3317__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulDirection </VAR> </b> Digital I/O direction. Each bit indicates if the channel is used as an input or an output. (0: input, 1: output)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulDirection parameter is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIOSetPortDirections(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulDirection;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIOSetPortDirections(modbus,ulPort,ulDirection,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIOSetPortDirections");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIOSetPortDirections\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIOSetPortDirections()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIOSetPortDirections OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIOSetPortDirections(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulDirection,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Sets the filter time for the digital inputs in steps of 250 ns (max value: 16777215)</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulFilterTime </VAR> </b> Filter time for the digital inputs in steps of 250 ns (max value: 16777215)
*		<ul>
* 			<li><b>0</b>: Disable the filter</li>
* 			<li><b>1</b>: Sets the filter time to 250 ns </li>
* 			<li><b>2</b>: Sets the filter time to 500 ns </li>
* 			<li>...</li>
* 			<li><b>16777215</b>: Sets the filter time to 4 s</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulFilterTime parameter is wrong</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIOSetInputsFilterTime(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulFilterTime;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIOSetInputsFilterTime(modbus,ulFilterTime,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIOSetInputsFilterTime");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIOSetInputsFilterTime\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIOSetInputsFilterTime()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIOSetInputsFilterTime OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIOSetInputsFilterTime(struct modbus * modbus,
	uint32_t ulFilterTime,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Enables/disables the digital input filter for the selected port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE3317__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulFilter </VAR> </b> Digital input filter selection. Each bit indicates if the filter is enabled on the input. (0: disabled, 1: enabled)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulFilterTime parameter is wrong</li>
*	<li><b>-4</b> Any selected input is not an input or a bidirectional channel</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIOEnableDisableInputsFilter(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulFilter;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIOEnableDisableInputsFilter(modbus,ulPort,ulFilter,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIOEnableDisableInputsFilter");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIOEnableDisableInputsFilter\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIOEnableDisableInputsFilter()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIOEnableDisableInputsFilter OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIOEnableDisableInputsFilter(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulFilter,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Rearm the digital outputs short circuit.</p>
* <p>Please use only this function if you detected a short circuit using the function MSXE3317__DigitalIOTestOutputsShortCircuit.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIORearmOutputsShortCircuit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIORearmOutputsShortCircuit(modbus,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIORearmOutputsShortCircuit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIORearmOutputsShortCircuit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIORearmOutputsShortCircuit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIORearmOutputsShortCircuit OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIORearmOutputsShortCircuit(struct modbus * modbus,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Set the selected digital output channel to on or off.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulChannel </VAR> </b> Selected digital I/O channel (0 to MSXE3317__DigitalIOGetNumberOfChannels).</li>
* 	<li>@param[in] <b> <VAR>ulState </VAR> </b> Digital I/O channel state (0: off, 1: on)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulChannel parameter is wrong</li>
*	<li><b>-3</b> The ulState parameter is wrong</li>
*	<li><b>-4</b> The selected digital I/O is not an output</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIOWriteChannel(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulState;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIOWriteChannel(modbus,ulChannel,ulState,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIOWriteChannel");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIOWriteChannel\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIOWriteChannel()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIOWriteChannel OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIOWriteChannel(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulState,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Write a value to the selected digital I/O port.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b> <VAR>ulPort </VAR> </b> Selected digital I/O port (0 to MSXE3317__DigitalIOGetNumberOfPorts).</li>
* 	<li>@param[in] <b> <VAR>ulState </VAR> </b> Digital I/O state. Each bit set the state for one digital I/O channel (0: off, 1: on)</li>
* 	<li>@param[in] <b> <VAR>ulOption1 </VAR> </b> Reserved. Set to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The ulPort parameter is wrong</li>
*	<li><b>-3</b> The ulState parameter is wrong</li>
*	<li><b>-4</b> Any digital I/O set to 1 is not an output channel</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__DigitalIOWritePort(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulState;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__DigitalIOWritePort(modbus,ulPort,ulState,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__DigitalIOWritePort");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__DigitalIOWritePort\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__DigitalIOWritePort()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__DigitalIOWritePort OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__DigitalIOWritePort(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulState,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise the selected Sine/Cosine channel.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> fSignalPeriod </VAR></b> Signal period (Unit/period) </li>
* 	<li>@param[in] <b><VAR> ulResolution </VAR></b> Resolution to use for the measure (steps/period)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption3 </VAR></b> Reserved. Set it to 0</li>
*	<li>@param[in] <b><VAR> ulOption4 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel has already been initialised. Please call the SinCosRelease and retry</li>
*	<li><b>-5</b> The fSignalPeriod parameter is wrong</li>
*	<li><b>-6</b> The ulResolution parameter is wrong</li>
*	<li><b>-7</b> Gain calibration error occurred. Please check the connection with the sensor</li>
*	<li><b>-21</b> Timeout while initialising the Sine/Cosine sensor. Please check the connection with the sensor</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosInit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	float fSignalPeriod;
	uint32_t ulResolution;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosInit(modbus,ulChannel,fSignalPeriod,ulResolution,ulOption01,ulOption02,ulOption03,ulOption04,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosInit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosInit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosInit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosInit OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosInit(struct modbus * modbus,
	uint32_t ulChannel,
	float fSignalPeriod,
	uint32_t ulResolution,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03,
	uint32_t ulOption04
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the selected Sine / Cosine channel.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosRelease(modbus,ulChannel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosRelease(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Clear the measured value of the selected Sine/Cosine channel.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosClear(modbus,ulChannel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosClear(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Clear the error flag of the selected Sine/Cosine channel.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosClearError(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosClearError(modbus,ulChannel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosClearError");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosClearError\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosClearError()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosClearError OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosClearError(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise the Index configuration. The index function enables to generate an event, or do an action, when the index signal occurs. This signal occurs one time per rotation for a rotary encoder, and one time per ride for a linear sensor (for more information see documentation of your sensor).</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulEdge </VAR></b>  Edge selection
*		<ul>
* 			<li><b>0b01 = 1</b>: Rising edge</li>
* 			<li><b>0b10 = 2</b>: Falling edge</li>
* 			<li><b>0b11 = 3</b>: Both edges</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulAction </VAR></b>  Action to do when the index trigger occurs
*		<ul>
*		 	<li><b>0b00 = 0</b>: Do nothing (but index trigger can also be used to trigger the acquisition)</li>
* 			<li><b>0b01 = 1</b>: Clear the value of the sensor</li>
* 			<li><b>0b10 = 2</b>: Generate a synchro trigger</li>
* 			<li><b>0b11 = 3</b>: Clear the value of the sensor AND Generate a synchro trigger</li>
*		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The ulEdge parameter is wrong</li>
*	<li><b>-5</b> The ulAction parameter is wrong</li>
*	<li><b>-6</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-7</b> The current status is not correct. The selected Sine/Cosine channel Index Logic has already been initialised. Please call the function SinCosReleaseIndex</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosInitIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulEdge;
	uint32_t ulAction;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosInitIndex(modbus,ulChannel,ulEdge,ulAction,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosInitIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosInitIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosInitIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosInitIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosInitIndex(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulEdge,
	uint32_t ulAction,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the Index configuration.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel Index Logic is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosReleaseIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosReleaseIndex(modbus,ulChannel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosReleaseIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosReleaseIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosReleaseIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosReleaseIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosReleaseIndex(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and enable a Sine/Cosine Compare Logic.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> fValue </VAR></b>  Compare value. Possible value depends on the variable ulValueFormat
* 		<ul>
* 			<li><b>If ulValueFormat is set to 0</b>: 0 to 0xFFFFFFFF</li>
* 			<li><b>If ulValueFormat is set to 1</b>: Standardised value (Unit). The value cannot be negative</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulValueFormat </VAR></b>  Format of the value fValue
* 		<ul>
* 			<li><b>0</b>: Raw value</li>
* 			<li><b>1</b>: Standardised value. The result of the operation dValue * (ulResolution / fSignalPeriod) must be an integer</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulMode </VAR></b>  Compare mode
* 		<ul>
* 			<li><b>0</b>: Simple mode. As soon as the counter value corresponds to the compare value (dValue), a trigger or synchro trigger is released.</li>
* 			<li><b>1</b>: Modulo mode. When the counter value corresponds to the compare value (dValue) or a multiple of it, a trigger or synchro trigger is released. In that mode, the value dValue cannot be 0.</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulSynchroTrigger </VAR></b>  Generate synchro trigger, which can be used to trigger another MSX-E system, when the compare trigger is released
* 		<ul>
* 			<li><b>0</b>: No</li>
* 			<li><b>1</b>: Yes</li>
* 		</ul>
*	</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The ulValueFormat parameter is wrong</li>
*	<li><b>-5</b> The ulMode parameter is wrong</li>
*	<li><b>-6</b> The ulMode parameter is wrong</li>
*	<li><b>-7</b> In Modulo mode, the parameter fValue cannot be 0</li>
*	<li><b>-8</b> The fValue parameter is wrong</li>
*	<li><b>-9</b> The current status is not correct. The selected Sine/Cosine channel is not initialised</li>
*	<li><b>-10</b> The current status is not correct. The selected Sine/Cosine channel Compare Logic has already been initialised. Please call the function SinCosDisableAndReleaseCompareLogic</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosInitAndEnableCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	float fValue;
	uint32_t ulValueFormat;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosInitAndEnableCompareLogic(modbus,ulChannel,fValue,ulValueFormat,ulMode,ulSynchroTrigger,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosInitAndEnableCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosInitAndEnableCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosInitAndEnableCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosInitAndEnableCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosInitAndEnableCompareLogic(struct modbus * modbus,
	uint32_t ulChannel,
	float fValue,
	uint32_t ulValueFormat,
	uint32_t ulMode,
	uint32_t ulSynchroTrigger,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release the Sine/Cosine Compare Logic.</p>
* <p><b>Parameters</b></p>
* <ul>
* 	<li>@param[in] <b><VAR> ulChannel </VAR></b>  Channel selection (0 to SinCosGetNumberOfChannels)</li>
* 	<li>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved. Set it to 0</li>
* 	<li>@param[in] <b><VAR> ulOption2 </VAR></b> Reserved. Set it to 0</li>
* </ul>
* <p><b>Returns</b></p>
* <p>Possible return value on the remote system (read them with GetLastCommandStatus).</p>
* <ul>
*	<li><b>0</b> The remote function performed OK</li>
*	<li><b>-2</b> The PLD is not working</li>
*	<li><b>-3</b> The ulChannel parameter is wrong</li>
*	<li><b>-4</b> The current status is not correct. The selected Sine/Cosine channel Compare Logic is not initialised</li>
*	<li><b>-100</b> Internal system error occurred. See value of syserrno</li>
* </ul>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE3317__SinCosDisableAndReleaseCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE3317__SinCosDisableAndReleaseCompareLogic(modbus,ulChannel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE3317__SinCosDisableAndReleaseCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE3317__SinCosDisableAndReleaseCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE3317__SinCosDisableAndReleaseCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE3317__SinCosDisableAndReleaseCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE3317__SinCosDisableAndReleaseCompareLogic(struct modbus * modbus,
	uint32_t ulChannel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE3317_CLIENT_DEFINITION_H_


