/* WARNING: this file is generated by modbus_server/Makefile.mk */
/* WARNING: modbus_server */
/** @file modbuscli.c MODBUS/TCP/UDP client sample for the MSXE3317
 *
 * FC16 queries are for setting things, FC3 for fetching values
 *
 * This code doesn't handle timeouts.
 */

#ifdef WIN32
	#include "../../Interface_Library/msxe3317_modbus_clientlib.h"
#else
	#include <msxe3317_modbus_clientlib.h>
#endif

#ifdef WIN32
	#include <windows.h>
	#define sleep(a) Sleep(a*1000)
#else
	#include <unistd.h>
#endif

#include <modbusclient.h>
#include <commonclient.h>

#include <addidata_console.h>
#include <addidata_network.h>
#include <addidata_dataclient.h>

	uint32_t  ulNbrOfDigIOChannels     = 0;
	uint32_t  ulNbrOfDigIOPorts        = 0;
	uint32_t  ulAvDirectionInputs [4]  = {0, 0, 0, 0};
	uint32_t  ulAvDirectionOutputs [4] = {0, 0, 0, 0};

	uint32_t ulNbrOfAcquisitionChannels    = 0;
	uint32_t ulNbrOfSequence               = 100;
	uint32_t ulAcquisitionChannelType [16] = {0};

// Get the acquisition channels information
int sample_MSXE3317__AcquisitionGetInformations (struct modbus * modbus)
{
	struct MSXE3317__AcquisitionGetNumberOfChannels_parameters_t ResponseGetChannels;
	struct MSXE3317__AcquisitionGetChannelsInfo_parameters_t     ResponseChannelInfo;
	int       iRet          = 0;
	uint32_t ulChannels     = 0;
	char      cType [9][32] = {"not available", "temperature", "pressure", "transducer", "analog input", "analog input ICP", "digital I/O port","incremental counter", "sine/cosine"};

	printf ("\nGet acquisition channels informations:\n");
	printf ("--------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));
	memset(&ResponseChannelInfo,0,sizeof(ResponseChannelInfo));

	/* Get the number of acquisition channels */
	iRet = modbus_call_MSXE3317__AcquisitionGetNumberOfChannels(modbus, &ResponseGetChannels);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__AcquisitionGetNumberOfChannels") )
	{
		return -1;
	}

	/* store */
	ulNbrOfAcquisitionChannels = ResponseGetChannels.ulNumber;
	printf ("Number of available acquisition channel(s) : %u\n", ulNbrOfAcquisitionChannels);

	/* Get the channels info */
	iRet = modbus_call_MSXE3317__AcquisitionGetChannelsInfo (modbus, &ResponseChannelInfo);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__AcquisitionGetChannelsInfo") )
	{
		return -1;
	}

	/* display an store */
	for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels++)
	{
		printf("Acquisition channel %2d connected to connector %u is a %s channel \n",ulChannels, ResponseChannelInfo.ulHwPosition[ulChannels], cType[ResponseChannelInfo.ulType[ulChannels]]);
		ulAcquisitionChannelType[ulChannels] = ResponseChannelInfo.ulType[ulChannels];
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();
	return 0;
}

// Pressure initialisation
int sample_MSXE3317__PressureChannelsInitialisation(struct modbus * modbus)
{
	struct MSXE3317__PressureGetNumberOfChannels_parameters_t   ResponseGetChannels;
	struct GetLastCommandStatus_parameters_t                               ResponseSetConfiguration;
	struct GetLastCommandStatus_parameters_t                               ResponseSetSamplingRate;
	int       iRet         = 0;
	uint32_t ulChannels    = 0;

	printf ("\nPressure channel(s) initialisation:\n");
	printf ("-----------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	iRet = modbus_call_MSXE3317__PressureGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__PressureGetNumberOfChannels") )
	{
		for (ulChannels = 0; ulChannels < ResponseGetChannels.ulNumber; ulChannels ++)
		{
			printf("Pressure channel %2d configuration : 1.0 sensor sensibility (mV/Vr/bar)", ulChannels);

			// Set the sensor sensibility to 1
			iRet = modbus_call_MSXE3317__PressureSetChannelConfiguration (modbus, (unsigned long) ulChannels, (float) 1.0, (float) 0.0, 0, &ResponseSetConfiguration);

			if (handle_result_of_FC16_query(modbus, &ResponseSetConfiguration, iRet, "modbus_call_MSXE3317__PressureSetChannelConfiguration"))
			{
				return (-1);
			}

			if ((ulChannels % 2) == 1)
			{
				printf ("Set the sampling rate for channel(s) %2d and %2d to 160Hz.\n\n", ulChannels - 1, ulChannels);

				iRet = modbus_call_MSXE3317__PressureSetSamplingRate (modbus, (unsigned long) (ulChannels >> 1), 160, 0, &ResponseSetSamplingRate);

				if (handle_result_of_FC16_query(modbus, &ResponseSetSamplingRate, iRet, "modbus_call_MSXE3317__PressureSetSamplingRate" ))
				{
					return (-1);
				}
			}
		}

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return (0);
	}
	return (-1);
}

// Get the digital I/O initialisation
int sample_MSXE3317__DigitalIOChannelsGetInitialisation(struct modbus * modbus)
{
	struct MSXE3317__DigitalIOGetNumberOfChannels_parameters_t           ResponseGetChannels;
	struct MSXE3317__DigitalIOGetNumberOfPorts_parameters_t	            ResponseGetPorts;
	struct MSXE3317__DigitalIOGetPortAvailableDirections_parameters_t    ResponseAvDirections;
	struct MSXE3317__DigitalIOGetPortDirections_parameters_t             ResponseCurDirections;
	struct MSXE3317__DigitalIOGetInputsFilterConfiguration_parameters_t  ResponseFilter;
	struct GetLastCommandStatus_parameters_t                                        GetResponse;
	char       cType[4][20]         = {"Error","Input", "Output", "Bidirectional"};
	char       cFilter[2][20]       = {"disabled", "enabled"};
	int        iRet                 = 0;
	uint32_t  ulPort	            = 0;

	printf ("\nPress a key to get the digital I/O initialisation:\n");
	printf ("--------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	/* Get the number of digital I/O channels */
	iRet = modbus_call_MSXE3317__DigitalIOGetNumberOfChannels(modbus, &ResponseGetChannels);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOGetNumberOfChannels") )
	{
		return (-1);
	}
	ulNbrOfDigIOChannels = ResponseGetChannels.ulNumber;
	printf("Number of digital I/O channels: %d\n", (int)ulNbrOfDigIOChannels);

	/* Get the number of digital I/O ports */
	iRet = modbus_call_MSXE3317__DigitalIOGetNumberOfPorts(modbus, &ResponseGetPorts);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOGetNumberOfPorts") )
	{
		return (-1);
	}
	ulNbrOfDigIOPorts = ResponseGetPorts.ulNumber;
	printf("Number of digital I/O ports: %d\n", (int)ulNbrOfDigIOPorts);

	/* loop through all the ports */
	for (ulPort = 0; ulPort < ulNbrOfDigIOPorts; ulPort++ )
	{
		unsigned long ulChannel = 0;

		/* select the port */
		iRet = modbus_call_MSXE3317__SetDataCursor (modbus, ulPort, &GetResponse);
		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__SetDataCursor" ))
		{
			return (-1);
		}

		/* get available direction */
		iRet = modbus_call_MSXE3317__DigitalIOGetPortAvailableDirections(modbus, &ResponseAvDirections);
		if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOGetPortAvailableDirections") )
		{
			return (-1);
		}

		/* store it */
		ulAvDirectionInputs  [ulPort] = ResponseAvDirections.ulInputs;
		ulAvDirectionOutputs [ulPort] = ResponseAvDirections.ulOutputs;

		/* Get the current directions */
		iRet = modbus_call_MSXE3317__DigitalIOGetPortDirections(modbus, &ResponseCurDirections);
		if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOGetPortDirections") )
		{
			return (-1);
		}

		/* Get the filter time and configuration */
		iRet = modbus_call_MSXE3317__DigitalIOGetInputsFilterConfiguration(modbus, &ResponseFilter);
		if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOGetInputsFilterConfiguration") )
		{
			return (-1);
		}

		/* for each channel of the port, display the current configuration */
		for ( ulChannel = 0; ulChannel < 32; ulChannel++ )
		{
			uint32_t  ulTest = 0;

			if ((((ulAvDirectionInputs[ulPort] >> ulChannel) & 1) == 0)
					&& (((ulAvDirectionOutputs[ulPort] >> ulChannel) & 1) == 0))
			{
				continue;
			}

			/* display the digital I/O type */
			ulTest = ((ulAvDirectionInputs[ulPort] >> ulChannel) & 1) + (((ulAvDirectionOutputs[ulPort] >> ulChannel) & 1) << 1);
			printf("Port: %d, Digital I/O channel %d type : %s.\n",(int)ulPort, (int)ulChannel, cType [ulTest]);

			/* Get the digital I/O configuration (input, output) */
			ulTest = (ResponseCurDirections.ulDirection >> ulChannel) & 1;
			printf("    Configured as: %s.\n", cType [ulTest + 1]);

			/* Get the digital I/O filter configuration - only if input, filter is not applied on the output */
			if ( ulTest == 0 )
			{
				ulTest = (ResponseFilter.ulFilter >> ulChannel) & 1;
				printf("    Filter time is %dns and %s for this channel.\n", ResponseFilter.ulFilterTime * 250, cFilter [ulTest]);
			}
		}
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

/* Convert a uint32 variable into char array */
void vConvertToBinary (uint32_t ulDig, char * pcBinary)
{
	int i       = 0;
	int iOffset = 0;
	for (i = 31; i >= 0; i --)
	{
		pcBinary[(31 - i) + iOffset] = '0' + (char) ((ulDig >> i) & 1);
		if (((31 - i) % 4) == 3)
		{
			iOffset ++;
			if (i == 0)
			{
				pcBinary[(31 - i) + iOffset] = 0;
			}
			else
			{
				pcBinary[(31 - i) + iOffset] = ' ';
			}
		}
	}
}

// Digital I/O test
int sample_MSXE3317__DigitalIOChannelsTest(struct modbus * modbus)
{
//	struct MSXE3317__DigitalIOReadChannel_parameters_t ResponseRdChannel;
//	struct MSXE3317__DigitalIOReadPort_parameters_t    ResponseRdPort;
	struct GetLastCommandStatus_parameters_t                      GetResponse;
	char       cState[2][20]        = {"Low", "High"};
//	char       cBianry[42]          = "";
	int        iRet                 = 0;
	int        iTests               = 0;
	uint32_t  ulPort                = 0;

	/* Loop through the ports */
	for (ulPort = 0; ulPort < ulNbrOfDigIOPorts; ulPort ++)
	{
		/* Set all available digital I/O as outputs */
		iRet = modbus_call_MSXE3317__DigitalIOSetPortDirections (modbus, ulPort, ulAvDirectionOutputs[ulPort], 0, &GetResponse);
		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__DigitalIOSetPortDirections" ))
		{
			return (-1);
		}

		/* Enable the filter for all inputs */
		iRet = modbus_call_MSXE3317__DigitalIOEnableDisableInputsFilter (modbus, ulPort, ulAvDirectionInputs[ulPort], 0, &GetResponse);
		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__DigitalIOEnableDisableInputsFilter" ))
		{
			return (-1);
		}
	}

	/* Set the filter to 1kHz for the digital inputs (1ms) */
	iRet = modbus_call_MSXE3317__DigitalIOSetInputsFilterTime (modbus, 4000, 0, &GetResponse);
	if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__DigitalIOSetInputsFilterTime" ))
	{
		return (-1);
	}

	printf ("\nPress a key to start the digital I/O channel test:\n");
	printf ("--------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	for (iTests = 0; iTests < 2; iTests ++)
	{
		uint32_t ulCurrentIndex = 0;

		/* loop through the ports */
		for (ulPort = 0; ulPort < ulNbrOfDigIOPorts; ulPort++ )
		{
			uint32_t ulChannel = 0;
			/* for each channel of the port */
			for ( ulChannel = 0; ulChannel < 32; ulChannel++ )
			{
				/* channel ? */
				if ((((ulAvDirectionInputs[ulPort] >> ulChannel) & 1) == 0)
						&& (((ulAvDirectionOutputs[ulPort] >> ulChannel) & 1) == 0))
				{
					continue;
				}

				/* only the possible outputs */
				if (((ulAvDirectionOutputs[ulPort] >> ulChannel) & 1) == 0)
				{
					ulCurrentIndex++;
					continue;
				}

				printf ("Set the channel %d of port %d (Global index: %d) %s\n", ulChannel, ulPort, ulCurrentIndex, cState[(iTests + 1) % 2]);
				/* Set the output high/low */
				iRet = modbus_call_MSXE3317__DigitalIOWriteChannel (modbus, ulCurrentIndex, (iTests + 1) % 2, 0, &GetResponse);
				if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__DigitalIOWriteChannel" ))
				{
					return (-1);
				}

				ulCurrentIndex++;
			}
		}

		sleep(1);
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

// Digital I/O diagnostic
int sample_MSXE3317__DigitalIODiagnostic(struct modbus * modbus)
{
	struct MSXE3317__DigitalIOTestOutputsShortCircuit_parameters_t ResponseDiagnostic;
	struct GetLastCommandStatus_parameters_t                                  GetResponse;
	char       cBinaryState[42]  = "";
	int        iRet         = 0;
	uint32_t  ulChannels    = 0;
	uint32_t  ulPorts       = 0;
	uint32_t  ulShortCircuitDetected = 0;

	printf ("\nPress a key to start the digital I/O diagnostic test:\n");
	printf ("-----------------------------------------------------\n\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	/* loop through all the ports */
	for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
	{
		/* Select the port */
		iRet = modbus_call_MSXE3317__SetDataCursor (modbus, ulPorts, &GetResponse);
		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__SetDataCursor" ))
		{
			return (-1);
		}

		/* Read the short-circuit diagnostic */
		iRet = modbus_call_MSXE3317__DigitalIOTestOutputsShortCircuit(modbus, &ResponseDiagnostic);
		if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOTestOutputsShortCircuit") )
		{
			return (-1);
		}

		/* Convert the current state into a string */
		vConvertToBinary (ResponseDiagnostic.ulState, cBinaryState);
		printf ("Digital I/O port %d diagnostic : %08XHex\n  Binary: %s\n", ulPorts, ResponseDiagnostic.ulState, cBinaryState);

		/* If we detect a short-circuit, display the channels that are concerned */
		if (ResponseDiagnostic.ulState != 0)
		{
			ulShortCircuitDetected = 1;
			for (ulChannels = 0; ulChannels < 32; ulChannels ++)
			{
				if (((ResponseDiagnostic.ulState >> ulChannels) & 1) != 1)
				{
					printf ("Port %d: Channel %d short circuited\n", ulPorts, ulChannels);
				}
			}
		}
	}

	/* Test if any short circuit occur */
	if (ulShortCircuitDetected != 0)
	{
		printf("\nPress a key to rearm the digital I/O channels\n\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		/* Make a rearm */
		iRet = modbus_call_MSXE3317__DigitalIORearmOutputsShortCircuit (modbus, 0, &GetResponse);
		if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__DigitalIORearmOutputsShortCircuit" ))
		{
			return (-1);
		}

		sleep(1);

		/* loop through all the ports */
		for (ulPorts = 0; ulPorts < ulNbrOfDigIOPorts; ulPorts ++)
		{
			/* Select the port */
			iRet = modbus_call_MSXE3317__SetDataCursor (modbus, ulPorts, &GetResponse);
			if (handle_result_of_FC16_query(modbus, &GetResponse, iRet, "modbus_call_MSXE3317__SetDataCursor" ))
			{
				return (-1);
			}

			/* Read the short-circuit diagnostic */
			iRet = modbus_call_MSXE3317__DigitalIOTestOutputsShortCircuit(modbus, &ResponseDiagnostic);
			if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__DigitalIOTestOutputsShortCircuit") )
			{
				return (-1);
			}

			/* Convert the current state into a string */
			vConvertToBinary (ResponseDiagnostic.ulState, cBinaryState);
			printf ("Digital I/O port %d diagnostic : %08XHex\n  Binary: %s\n", ulPorts, ResponseDiagnostic.ulState, cBinaryState);

			/* If we detect a short-circuit, display the channels that are concerned */
			if (ResponseDiagnostic.ulState != 0)
			{
				ulShortCircuitDetected = 1;
				for (ulChannels = 0; ulChannels < 32; ulChannels ++)
				{
					if (((ResponseDiagnostic.ulState >> ulChannels) & 1) != 1)
					{
						printf ("Port %d: Channel %d short circuited\n", ulPorts, ulChannels);
					}
				}
			}
		}
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

// Initialise, Clear the error flag, Read the value, Clear the value and release a Sine/Cosine
int sample_MSXE3317__SineCosineSample(struct modbus * modbus)
{
	struct MSXE3317__SinCosGetNumberOfChannels_parameters_t	ResponseGetChannels;
	struct MSXE3317__SinCosRead_parameters_t					ResponseRead;
	struct GetLastCommandStatus_parameters_t 							Response;
	int       iRet         = 0;

	printf ("\nSine/Cosine sample. Please make sure a sensor is connected to the Sine/Cosine channel 0.\n");
	printf ("------------------------------------------------------------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	// Get the number of Sine/Cosine channels
	iRet = modbus_call_MSXE3317__SinCosGetNumberOfChannels(modbus, &ResponseGetChannels);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__SinCosGetNumberOfChannels") )
	{
		return (-1);
	}

	// At least one channel
	if ( ResponseGetChannels.ulNumber <= 0)
	{
		printf("The selected system does not have Sine/Cosine channel.\n");
		return 0;
	}

	printf("Release the first channel.\n");
	modbus_call_MSXE3317__SinCosRelease (modbus, 0, 0, 0, &Response);

	// Initialise the first channel
	// Uses:
	// Signal period: 0.002
	// Resolution: 16
	printf("Initialise the first channel (signal period: 0.002, resolution: 16).\n");
	iRet = modbus_call_MSXE3317__SinCosInit (modbus, 0, 0.002, 16, 0, 0, 0, 0, &Response);
	if (handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__SinCosInit"))
	{
		return (-1);
	}

	printf("Clear the error flags.\n");
	iRet = modbus_call_MSXE3317__SinCosClearError (modbus, 0, 0, 0, &Response);
	if (handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__SinCosClearError"))
	{
		return (-1);
	}

	printf("Select the first channel.\n");
	iRet = modbus_call_MSXE3317__SetDataCursor (modbus, 0, &Response);
	if (handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__SetDataCursor"))
	{
		return (-1);
	}

	printf("Sleep during 2 seconds.\n");
	sleep(2);

	printf("Read its value.\n");
	iRet = modbus_call_MSXE3317__SinCosRead(modbus, &ResponseRead);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__SinCosRead") )
	{
		return (-1);
	}
	printf("Sine/Cosine value:\n");
	printf("fValue (standardised): %f\n", ResponseRead.fValue);
	printf("ulValue (raw): %u\n", ResponseRead.ulValue);
	printf("Measuring error: %u\n", ResponseRead.ulMeasureError);

	printf("Clear the value.\n");
	iRet = modbus_call_MSXE3317__SinCosClear (modbus, 0, 0, 0, &Response);
	if (handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__SinCosClear"))
	{
		return (-1);
	}

	printf("Release the first channel.\n");
	iRet = modbus_call_MSXE3317__SinCosRelease (modbus, 0, 0, 0, &Response);
	if (handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__SinCosRelease"))
	{
		return (-1);
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return (0);
}

// Auto refresh start
int sample_MSXE3317__AcquisitionAutoRefreshInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannelMask                = (1 << ulNbrOfAcquisitionChannels) - 1;
	uint32_t ulAverageValue               = 1;
	uint32_t ulRefreshTime                = 200;
	uint32_t ulRefreshTimeUnit            = 1;
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf("\nPress a key to start the auto refresh acquisition.\n");
	printf("--------------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	printf ("\nAuto refresh acquistion initialisation and start:\n");
	printf ("-------------------------------------------------\n");

	printf ("Channel mask                : %04X Hex\n", ulChannelMask);
	printf ("Average value               : %u\n",       ulAverageValue);
	printf ("Refresh time                : %u\n",       ulRefreshTime);
	printf ("Refresh time unit           : %u\n",       ulRefreshTimeUnit);
	printf ("Trigger mask                : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge             : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count            : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire  : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                 : %X Hex\n",   ulDataFormat);

	iRet = modbus_call_MSXE3317__AcquisitionAutoRefreshInitAndStart (modbus,
	                                                                            ulChannelMask,
	                                                                            ulAverageValue,
	                                                                            ulRefreshTime,
	                                                                            ulRefreshTimeUnit,
	                                                                            ulTriggerMask,
	                                                                            ulTriggerMode,
	                                                                            ulHardwareTriggerEdge,
	                                                                            ulHardwareTriggerCount,
	                                                                            ulByTriggerNbrOfSeqToAcquire,
	                                                                            ulDataFormat,
	                                                                            ulForceStart,
	                                                                            ulOption1,
	                                                                            ulOption2,
	                                                                            ulOption3,
	                                                                            &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__AcquisitionAutoRefreshInitAndStart" );
}

// Auto refresh read
int sample_MSXE3317__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus)
{
	struct MSXE3317__AcquisitionAutoRefreshGetBlockingValues_parameters_t Response;
	int       iRet      = 0;
	uint32_t ulChannels = 0;

	memset(&Response,0,sizeof(Response));

	/* Get a value from the auto-refresh acquisition and display it */
	iRet = modbus_call_MSXE3317__AcquisitionAutoRefreshGetBlockingValues(modbus, &Response);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__AcquisitionAutoRefreshGetBlockingValues") )
	{
		return -1;
	}

	/**
	 *  Display the value.
	 *  The algorithm assumes that the "Data Format" analog is selected
	 *  */
	printf("Counter: %10u\ts: %10u\tmicro s:%6u\n",Response.ulCounterValue,Response.ulTimeStampHigh, Response.ulTimeStampLow);
	for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels ++)
	{
		switch (ulAcquisitionChannelType[ulChannels])
		{
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 8:
				/* Types 0,1,2,3,4,5,8 supports float conversion */
				printf("\tChannel %d = %f\n", ulChannels, Response.fValues[ulChannels]);
				break;
			case 6:
			case 7:
				/* Types 6 and 7 does not support float conversion */
				{
					int iValue = (int)Response.fValues[ulChannels];
					printf("\tChannel %d = %d\n", ulChannels, iValue);
					break;
				}
			default:
				printf("\tChannel %d = %f\n", ulChannels, Response.fValues[ulChannels]);
		}
	}

	return 0;
}

// Auto refresh release
int sample_MSXE3317__AcquisitionAutoRefreshStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the auto refresh acquisition:\n");
	printf ("----------------------------------------------\n");

	iRet = modbus_call_MSXE3317__AcquisitionAutoRefreshStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__AcquisitionAutoRefreshStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE3317__AcquisitionAutoRefreshGetConfiguration (struct modbus * modbus)
{
	struct MSXE3317__AcquisitionAutoRefreshGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast auto refresh acquisition configuration:\n");
	printf ("--------------------------------------------\n");

	iRet = modbus_call_MSXE3317__AcquisitionAutoRefreshGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__AcquisitionAutoRefreshGetConfiguration") )
	{
		printf ("Channel mask                : %04X Hex\n", Response.ulChannelMask);
		printf ("Average value               : %u\n",       Response.ulAverageValue);
		printf ("Refresh time                : %u\n",       Response.ulRefreshTime);
		printf ("Refresh time unit           : %u\n",       Response.ulRefreshTimeUnit);
		printf ("Trigger mask                : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge             : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count            : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire  : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                 : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                     : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

// Sequence start
int sample_MSXE3317__AcquisitionSequenceInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannels                   = 0;
	uint32_t ulNbrOfChannel               = ulNbrOfAcquisitionChannels;
	uint32_t ulChannelList [16];
	uint32_t ulAcquisitionTime            = 100;
	uint32_t ulAcquisitionTimeUnit        = 1;
	uint32_t ulNbrMaxSequenceToTransfer   = 2;
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf ("\nSequence acquisition initialisation and start:\n");
	printf ("---------------------------------------------\n");

	printf ("Number of selected channels     : %u\n",       ulNbrOfChannel);
	printf ("Acquisition time                : %u\n",       ulAcquisitionTime);
	printf ("Acquisition time unit           : %u\n",       ulAcquisitionTimeUnit);
	printf ("Number of sequences             : %u\n",       ulNbrOfSequence);
	printf ("Number of sequences to transfer : %u\n",       ulNbrMaxSequenceToTransfer);
	printf ("Trigger mask                    : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                    : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge                 : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count                : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire      : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                     : %X Hex\n\n", ulDataFormat);

	for (ulChannels = 0; ulChannels < ulNbrOfChannel; ulChannels ++)
	{
		ulChannelList[ulChannels] = ulChannels;
	}

	iRet = modbus_call_MSXE3317__AcquisitionSequenceInitAndStart (modbus,
	                                                                         ulNbrOfChannel,
	                                                                         ulChannelList,
	                                                                         ulAcquisitionTime,
	                                                                         ulAcquisitionTimeUnit,
	                                                                         ulNbrOfSequence,
	                                                                         ulNbrMaxSequenceToTransfer,
	                                                                         ulTriggerMask,
	                                                                         ulTriggerMode,
	                                                                         ulHardwareTriggerEdge,
	                                                                         ulHardwareTriggerCount,
	                                                                         ulByTriggerNbrOfSeqToAcquire,
	                                                                         ulDataFormat,
	                                                                         ulForceStart,
	                                                                         ulOption1,
	                                                                         ulOption2,
	                                                                         ulOption3,
	                                                                         &Response);

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__AcquisitionSequenceInitAndStart" );
}

// Sequence release
int sample_MSXE3317__AcquisitionSequenceStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the sequence acquistion:\n");
	printf ("-----------------------------------------\n");

	iRet = modbus_call_MSXE3317__AcquisitionSequenceStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE3317__AcquisitionSequenceStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE3317__AcquisitionSequenceGetConfiguration (struct modbus * modbus)
{
	struct MSXE3317__AcquisitionSequenceGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast sequence acquisition configuration:\n");
	printf ("----------------------------------------\n");

	iRet = modbus_call_MSXE3317__AcquisitionSequenceGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE3317__AcquisitionSequenceGetConfiguration") )
	{
		printf ("Number of selected channels     : %u\n",       Response.ulNbrOfChannel);
		printf ("Acquisition time                : %u\n",       Response.ulAcquisitionTime);
		printf ("Acquisition time unit           : %u\n",       Response.ulAcquisitionTimeUnit);
		printf ("Number of sequences             : %u\n",       Response.ulNbrOfSequence);
		printf ("Number of sequences to transfer : %u\n",       Response.ulNbrMaxSequenceToTransfer);
		printf ("Trigger mask                    : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                    : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge                 : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count                : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire      : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                     : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                         : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

//---------------------------------------------------------------------------------
static void usage(char* name)
{
	printf("%s ADDRESS tcp|udp\n",name);
}

//---------------------------------------------------------------------------------

int main(int argc, char** argv)
{
	struct modbus modbus;
	int contype = SOCK_DGRAM;
	int       iFd = 0;
	uint32_t ulDatas[16 + 4];
	float*   pfDatas      = (float *) &ulDatas[4];
	uint32_t ulChannels   = 0;
	uint32_t ulCount      = 0;
	uint32_t ulFrameCount = 0;

	if (argc != 3)
	{
		usage(argv[0]);
		exit(1);
	}

	if (0 == strcmp(argv[2],"tcp"))
	{
		contype=SOCK_STREAM;
	}
	else if(0 == strcmp(argv[2],"udp"))
	{
		contype=SOCK_DGRAM;
	}
	else
	{
		usage(argv[0]);
		exit(1);
	}

	modbus_init(&modbus);

	switch( modbus_connect(&modbus, argv[1], contype, 0) )
	{
		case 0: /* success */
			break;
		case -1: /* system error */
			addidata_network_perror("modbus_connect");
			exit(1);
		case -2: /* parameter is incorrect */
			printf("modbus_connect: incorrect parameter\n");
			exit(1);
		case -3: /* incorrect address */
			printf("incorrect address\n");
			exit(1);
	}

	// Get the digital I/O initialisation
	assert( sample_MSXE3317__DigitalIOChannelsGetInitialisation(&modbus) == 0);

	// Digital I/O diagnostic
	assert( sample_MSXE3317__DigitalIODiagnostic(&modbus) == 0);

	// Test the digital I/O
	assert( sample_MSXE3317__DigitalIOChannelsTest(&modbus) == 0);

	// Digital I/O diagnostic
	assert( sample_MSXE3317__DigitalIODiagnostic(&modbus) == 0);

	assert( sample_MSXE3317__AcquisitionGetInformations(&modbus) == 0);

	// Pressure initialisation
	assert( sample_MSXE3317__PressureChannelsInitialisation(&modbus) == 0);

	assert( sample_MSXE3317__SineCosineSample(&modbus) == 0);

	/* autorefresh */
	assert( sample_MSXE3317__AcquisitionAutoRefreshInitAndStart(&modbus) == 0);
	{
		int i;
		for(i=0;i<100;i++)
		{
			printf("Value %d/100\n", i);
			assert( sample_MSXE3317__AcquisitionAutoRefreshGetBlockingValues(&modbus) == 0);
		}
	}

	assert( sample_MSXE3317__AcquisitionAutoRefreshStopAndRelease(&modbus) == 0);

	assert( sample_MSXE3317__AcquisitionAutoRefreshGetConfiguration(&modbus) == 0);

	printf("\nPress a key to start the sequence acquisition.\n");
	printf("----------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	/* connect to data server */
	switch(addidata_dataclient_tcp_connect(argv[1], 0, &iFd))
	{
		case 0: /* OK */
			break;
		case -1:
			addidata_network_perror("socket");
			exit(1);
		case -2:
			addidata_network_perror("connect");
			exit(1);
		case -3:
			printf("error while parsing address\n");
			exit(1);
		case -4:
			addidata_network_perror("WSACleanup() failed");
			exit(1);
	}

	/* sequence */
	assert( sample_MSXE3317__AcquisitionSequenceInitAndStart(&modbus) == 0);

	ulCount = ulNbrOfAcquisitionChannels + 4;

	/**
	 * Receive all the frames from the system
	 * The algorithm assumes that the "Data Format" is analog
	 * The algorithm also assumes that the sequence list is the list of the acquisition channels
	 * of the system in the right order
	 */
	for(ulFrameCount=0; ulFrameCount < ulNbrOfSequence; ulFrameCount++)
	{
		printf("Value %u/%u\n", ulFrameCount, ulNbrOfSequence);

		/* receive per socket */
		if( -1 == addidata_dataclient_recvall(iFd, ulDatas, (int) ulCount) )
		{
			addidata_network_perror("fetch");
			assert( sample_MSXE3317__AcquisitionSequenceStopAndRelease(&modbus) == 0);
			exit(1);
		}

		/* display */
		printf("Counter: %10u\ts: %10u\tmicro s:%6u\tSystem status information :%u\n",ulDatas[2],ulDatas[0],ulDatas[1],ulDatas[3]);
		for (ulChannels = 0; ulChannels < (ulCount - 4); ulChannels ++)
		{
			switch (ulAcquisitionChannelType[ulChannels])
			{
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 8:
					/* Types 0,1,2,3,4,5,8 supports float conversion */
					printf("\tChannel %d = %f\n", ulChannels, pfDatas[ulChannels]);
					break;
				case 6:
				case 7:
					/* Types 6 and 7 does not support float conversion */
					printf("\tChannel %d = %u\n", ulChannels, ulDatas[4 + ulChannels]);
					break;
				default:
					printf("\tChannel %d = %f\n", ulChannels, pfDatas[ulChannels]);
			}
		}
	}

	addidata_dataclient_disconnect(iFd);

	assert( sample_MSXE3317__AcquisitionSequenceStopAndRelease(&modbus) == 0);

	assert( sample_MSXE3317__AcquisitionSequenceGetConfiguration(&modbus) == 0);

	printf("\nPress a key to end this sample\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return 0;
}
/* WARNING: this file is generated by modbus_server/Makefile.mk */
