using System;
using System.Collections.Generic;
using System.Text;

namespace Configuration
{
    public class NetworkHelper
    {
        /// <summary>
        /// This function enables to check if an ip address is correct.
        /// </summary>
        /// <param name="ip1"></param>
        /// <param name="ip2"></param>
        /// <param name="ip3"></param>
        /// <param name="ip4"></param>
        /// <returns>true if correct, false if not</returns>
        public static bool isIpCorrect(string ip1, string ip2, string ip3, string ip4)
        {
            int i = 0;
            string[] ipArray = new string[] { ip1, ip2, ip3, ip4 };

            // Check null element
            if (ip1 == null || ip2 == null || ip3 == null || ip4 == null)
            {
                return false;
            }

            // Check the value
            for (i = 0; i < 4; i++)
            {
                try
                {
                    int ipField = Convert.ToInt32(ipArray[i]);
                    if (ipField < 0 || ipField > 255)
                    {
                        return false;
                    }
                }
                catch (Exception)
                {
                    return false;
                }
            }

            // Ok
            return true;
        }
    }
}
